diff a/test/hotspot/jtreg/runtime/cds/appcds/leyden/LeydenGCFlags.java b/test/hotspot/jtreg/runtime/cds/appcds/leyden/LeydenGCFlags.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/leyden/LeydenGCFlags.java
@@ -0,0 +1,194 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+/*
+ * @test
+ * @summary CDS should fail to load if production time GC flags do not match training run.
+ * @requires vm.flagless
+ * @requires vm.cds.write.archived.java.heap
+ * @library /test/jdk/lib/testlibrary /test/lib
+ * @build LeydenGCFlags
+ * @run driver jdk.test.lib.helpers.ClassFileInstaller jdk.test.whitebox.WhiteBox
+ * @run driver jdk.test.lib.helpers.ClassFileInstaller -jar app.jar HelloApp
+ * @run main/othervm -Xbootclasspath/a:. -XX:+UnlockDiagnosticVMOptions -XX:+WhiteBoxAPI LeydenGCFlags
+ */
+
+import jdk.test.whitebox.WhiteBox;
+import jdk.test.whitebox.gc.GC;
+
+import jdk.test.lib.cds.CDSAppTester;
+import jdk.test.lib.helpers.ClassFileInstaller;
+import jdk.test.lib.process.OutputAnalyzer;
+import jdk.test.lib.StringArrayUtils;
+
+public class LeydenGCFlags {
+    static final String appJar = ClassFileInstaller.getJarPath("app.jar");
+    static final String mainClass = "HelloApp";
+    static final String ERROR_GC_SUPPORTED = "Cannot create the CacheDataStore: UseCompressedClassPointers must be enabled, and collector must be G1, Parallel, Serial, Epsilon, or Shenandoah";
+    static final String ERROR_GC_MISMATCH = "CDS archive has aot-linked classes. It cannot be used because GC used during dump time (.*) is not the same as runtime (.*)";
+    static final String ERROR_COOP_MISMATCH = "Disable Startup Code Cache: 'HelloApp.cds.code' was created with CompressedOops::shift.. = .* vs current .*";
+
+    static String trainingArgs[];
+    static String productionArgs[];
+    static boolean shouldFailDump;
+    static boolean shouldFailRun;
+    static String productFailPattern;
+
+    public static void main(String[] args) throws Exception {
+        if (GC.Z.isSupported()) {
+            // ZGC not supported for now
+            fail_dump("-XX:+UseZGC",  "-Xmx8g",  ERROR_GC_SUPPORTED);
+        }
+
+        // Serial, Parallel and Shenandoah collectors are allowed to be used,
+        // as long as the same one is used between training and production
+        if (GC.Serial.isSupported()) {
+            good("-XX:+UseSerialGC",   "-XX:+UseSerialGC");
+        }
+        if (GC.Parallel.isSupported()) {
+            good("-XX:+UseParallelGC", "-XX:+UseParallelGC");
+        }
+        if (GC.Shenandoah.isSupported()) {
+            good("-XX:+UseShenandoahGC", "-XX:+UseShenandoahGC");
+        }
+
+        // Fail if production uses a different collector than training
+        if (GC.Parallel.isSupported() && GC.G1.isSupported()) {
+            fail_run("-XX:+UseParallelGC", "-XX:+UseG1GC",        ERROR_GC_MISMATCH );
+        }
+        if (GC.Parallel.isSupported()) {
+            fail_run(null,                 "-XX:+UseParallelGC",  ERROR_GC_MISMATCH );
+        }
+
+       if (false) { // Disabled for now, as on MacOS we cannot guarantee to get differnt coop encodings
+        // Different oop encodings
+        fail_run(array("-XX:-UseCompatibleCompressedOops", "-Xmx128m"), 
+                 array("-XX:-UseCompatibleCompressedOops","-Xmx8g"),
+                 ERROR_COOP_MISMATCH);
+        fail_run(array("-XX:-UseCompatibleCompressedOops", "-Xmx8g"),
+                 array("-XX:-UseCompatibleCompressedOops","-Xmx128m"),
+                 ERROR_COOP_MISMATCH);
+       }
+
+        // FIXME -- this causes
+        // java.lang.invoke.WrongMethodTypeException: handle's method type ()Object but found ()Object
+     /* fail_run(null,                 "NoSuchApp"); */
+    }
+
+    static String[] array(String... strings) {
+        return strings;
+    }
+    static void good(Object t, Object p) throws Exception {
+        shouldFailDump = false;
+        shouldFailRun = false;
+        run(t, p);
+    }
+
+    static void fail_dump(Object t, Object p, String regexp) throws Exception {
+        shouldFailDump = true;
+        shouldFailRun  = true;
+        productFailPattern = regexp;
+        trainingArgs = makeArgs(t);
+        productionArgs = makeArgs(p);
+        Tester tester = new Tester();
+        tester.setCheckExitValue(false);
+        tester.run(new String[] {"LEYDEN_TRAINONLY"} );
+    }
+
+    static void fail_run(Object t, Object p, String regexp) throws Exception {
+        shouldFailDump = false;
+        shouldFailRun  = true;
+        productFailPattern = regexp;
+        run(t, p);
+    }
+
+    static void run(Object t, Object p) throws Exception {
+        trainingArgs = makeArgs(t);
+        productionArgs = makeArgs(p);
+        Tester tester = new Tester();
+        tester.run(new String[] {"LEYDEN"} );
+    }
+
+    static String[] makeArgs(Object o) {
+        if (o == null) {
+            return new String[0];
+        }
+        if (o instanceof String[]) {
+            return (String[])o;
+        } else {
+            return new String[] { (String)o };
+        }
+    }
+
+    static class Tester extends CDSAppTester {
+        public Tester() {
+            super(mainClass);
+        }
+
+        @Override
+        public String classpath(RunMode runMode) {
+            return appJar;
+        }
+
+        @Override
+        public String[] appCommandLine(RunMode runMode) {
+            if (runMode.isProductionRun()) {
+                return StringArrayUtils.concat(productionArgs, "-Xshare:auto", mainClass);
+            } else {
+                return StringArrayUtils.concat(trainingArgs, mainClass);
+            }
+        }
+
+        @Override
+        public void checkExecution(OutputAnalyzer out, RunMode runMode) {
+            if (shouldFailDump) {
+                if (runMode != RunMode.PRODUCTION) {
+                    out.shouldMatch(productFailPattern);
+                    out.shouldHaveExitValue(1);
+                }
+            } else if (shouldFailRun) {
+                if (runMode == RunMode.PRODUCTION) {
+                    out.shouldMatch(productFailPattern);
+                    //out.shouldHaveExitValue(1); TODO VM should enable -Xshare:on by default
+                }
+            } else {
+                if (runMode != RunMode.TRAINING1) {
+                    out.shouldContain("Hello Leyden");
+                }
+
+                if (runMode == RunMode.TRAINING || runMode == RunMode.TRAINING1) {
+                    // We should dump the heap even if the collector is not G1
+                    out.shouldContain("Shared file region (hp)");
+                }
+
+            }
+        }
+    }
+}
+
+class HelloApp {
+    public static void main(String args[]) {
+        System.out.println("Hello Leyden");
+    }
+}
diff a/test/hotspot/jtreg/runtime/cds/appcds/leyden/LeydenHello.java b/test/hotspot/jtreg/runtime/cds/appcds/leyden/LeydenHello.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/leyden/LeydenHello.java
@@ -0,0 +1,77 @@
+/*
+ * Copyright (c) 2023, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+/*
+ * @test
+ * @requires vm.cds.write.archived.java.heap
+ * @library /test/jdk/lib/testlibrary /test/lib
+ * @build LeydenHello
+ * @run driver jdk.test.lib.helpers.ClassFileInstaller -jar app.jar LeydenHelloApp
+ * @run driver LeydenHello LEYDEN
+ */
+
+import jdk.test.lib.cds.CDSAppTester;
+import jdk.test.lib.helpers.ClassFileInstaller;
+import jdk.test.lib.process.OutputAnalyzer;
+
+public class LeydenHello {
+    static final String appJar = ClassFileInstaller.getJarPath("app.jar");
+    static final String mainClass = "LeydenHelloApp";
+
+    public static void main(String[] args) throws Exception {
+        Tester t = new Tester();
+        t.run(args);
+    }
+
+    static class Tester extends CDSAppTester {
+        public Tester() {
+            super(mainClass);
+        }
+
+        @Override
+        public String classpath(RunMode runMode) {
+            return appJar;
+        }
+
+        @Override
+        public String[] appCommandLine(RunMode runMode) {
+            return new String[] {
+                mainClass, runMode.name()
+            };
+        }
+
+        @Override
+        public void checkExecution(OutputAnalyzer out, RunMode runMode) {
+            if (!runMode.isStaticDump()) {
+                out.shouldContain("Hello Leyden " + runMode.name());
+            }
+        }
+    }
+}
+
+class LeydenHelloApp {
+    public static void main(String args[]) {
+        System.out.println("Hello Leyden " + args[0]);
+    }
+}
diff a/test/hotspot/jtreg/runtime/cds/appcds/leyden/LeydenReflection.java b/test/hotspot/jtreg/runtime/cds/appcds/leyden/LeydenReflection.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/leyden/LeydenReflection.java
@@ -0,0 +1,91 @@
+/*
+ * Copyright (c) 2023, 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+/*
+ * @test
+ * @requires vm.cds.write.archived.java.heap
+ * @library /test/jdk/lib/testlibrary /test/lib
+ * @build LeydenReflection
+ * @run driver jdk.test.lib.helpers.ClassFileInstaller -jar app.jar LeydenReflectionApp
+ * @run driver LeydenReflection LEYDEN
+ */
+
+import java.lang.reflect.Method;
+import jdk.test.lib.cds.CDSAppTester;
+import jdk.test.lib.helpers.ClassFileInstaller;
+import jdk.test.lib.process.OutputAnalyzer;
+
+public class LeydenReflection {
+    static final String appJar = ClassFileInstaller.getJarPath("app.jar");
+    static final String mainClass = "LeydenReflectionApp";
+
+    public static void main(String[] args) throws Exception {
+        Tester t = new Tester();
+        t.run(args);
+    }
+
+    static class Tester extends CDSAppTester {
+        public Tester() {
+            super(mainClass);
+        }
+
+        @Override
+        public String classpath(RunMode runMode) {
+            return appJar;
+        }
+
+        @Override
+        public String[] appCommandLine(RunMode runMode) {
+            return new String[] {
+                mainClass, runMode.name()
+            };
+        }
+
+        @Override
+        public void checkExecution(OutputAnalyzer out, RunMode runMode) {
+            if (!runMode.isStaticDump()) {
+                out.shouldContain("Hello Leyden Reflection " + runMode.name());
+            }
+
+            if (runMode == RunMode.DUMP_STATIC || runMode == RunMode.TRAINING || runMode == RunMode.TRAINING1) {
+              out.shouldContain("Generate ReflectionData: LeydenReflectionApp");
+              out.shouldContain("Generate ReflectionData: java.util.Random");
+            }
+        }
+    }
+}
+
+class LeydenReflectionApp {
+    public static void main(String args[]) throws Exception {
+        // Random.<clinit> calls Random.class.getDeclaredField("seed")
+        Object x = new java.util.Random();
+
+        Method m = LeydenReflectionApp.class.getDeclaredMethod("sayHello", String.class);
+        m.invoke(null, args[0]);
+    }
+
+    static void sayHello(String s) {
+        System.out.println("Hello Leyden Reflection " + s);
+    }
+}
diff a/test/hotspot/jtreg/runtime/cds/appcds/leyden/OldClass.jasm b/test/hotspot/jtreg/runtime/cds/appcds/leyden/OldClass.jasm
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/leyden/OldClass.jasm
@@ -0,0 +1,36 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+super public class OldClass
+	version 50:0
+{
+  public Method "<init>":"()V"
+	stack 1 locals 1
+  {
+		aload_0;
+		invokespecial	Method java/lang/Object."<init>":"()V";
+		return;
+  }
+
+} // end Class OldClass
diff a/test/hotspot/jtreg/runtime/cds/appcds/leyden/test-classes/Custy.java b/test/hotspot/jtreg/runtime/cds/appcds/leyden/test-classes/Custy.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/leyden/test-classes/Custy.java
@@ -0,0 +1,43 @@
+/*
+ * Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+public class Custy {
+    volatile static int cnt;
+
+    @Override
+    public boolean equals(Object other) {
+        long start = System.currentTimeMillis();
+        while (System.currentTimeMillis() - start < 20) {
+            cnt += 2;
+            for (int i = 0; i < 1000; i++) {
+                int n = cnt - 2;
+                if (n < 2) {
+                    n = 2;
+                }
+                cnt += (i + cnt) % n + cnt % 2;
+            }
+        }
+        return (cnt % 17) == 8;
+    }
+}
diff a/test/hotspot/jtreg/runtime/cds/appcds/leyden/testpkg/PublicTester.java b/test/hotspot/jtreg/runtime/cds/appcds/leyden/testpkg/PublicTester.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/leyden/testpkg/PublicTester.java
@@ -0,0 +1,62 @@
+/*
+ * Copyright (c) 2023, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+package testpkg;
+
+import java.lang.reflect.InvocationHandler;
+import java.lang.reflect.Method;
+import java.lang.reflect.Proxy;
+
+import jdk.test.lib.Asserts;
+
+public class PublicTester {
+    public static Class<?> test() {
+        NonPublicInterface npi = (NonPublicInterface) Proxy.newProxyInstance(
+            PublicTester.class.getClassLoader(), 
+            new Class[] { NonPublicInterface.class, Runnable.class },
+            new MyInvocationHandler2());
+        System.out.println(npi.getClass());
+        System.out.println(npi.getClass().getPackage());
+        System.out.println(npi.getClass().getModule());
+        System.out.println(PublicTester.class.getModule());
+        System.out.println(npi.m());
+
+        Asserts.assertSame(PublicTester.class.getModule(), npi.getClass().getModule(),
+                           "proxies for non-public interfaces should be in same module as the interface");
+        Asserts.assertSame(PublicTester.class.getPackage(), npi.getClass().getPackage(),
+                           "proxies for non-public interfaces should be in same package as the interface");
+
+        return npi.getClass();
+    }
+}
+
+class MyInvocationHandler2 implements InvocationHandler {
+    public Object invoke(Object proxy, Method method, Object[] args) throws Throwable {
+        return method.getName() + " in() " + proxy.getClass() + " is called";
+    }
+}
+
+interface NonPublicInterface {
+    Object m();
+}
diff a/test/hotspot/jtreg/runtime/cds/appcds/resolvedConstants/ResolvedConstants.java b/test/hotspot/jtreg/runtime/cds/appcds/resolvedConstants/ResolvedConstants.java
--- a/test/hotspot/jtreg/runtime/cds/appcds/resolvedConstants/ResolvedConstants.java
+++ b/test/hotspot/jtreg/runtime/cds/appcds/resolvedConstants/ResolvedConstants.java
@@ -85,17 +85,18 @@
             .shouldMatch(ALWAYS("klass.* ResolvedConstantsBar app => ResolvedConstantsFoo app"))
 
             // Always resolve reference when a class references a super interface
             .shouldMatch(ALWAYS("klass.* ResolvedConstantsApp app => java/lang/Runnable boot"))
 
+/** premain allows static method pre-resolution
             // Without -XX:+AOTClassLinking:
             //   java/lang/System is in the boot loader but ResolvedConstantsApp is loaded by the app loader.
             //   Even though System is in the vmClasses list, when ResolvedConstantsApp looks up
             //   "java/lang/System" in its ConstantPool, the app loader may not have resolved the System
             //   class yet (i.e., there's no initiaited class entry for System in the app loader's dictionary)
             .shouldMatch(AOTLINK_ONLY("klass.* ResolvedConstantsApp .*java/lang/System"))
-
+**/
           // Field References ---
 
             // Always resolve references to fields in the current class or super class(es)
             .shouldMatch(ALWAYS("field.* ResolvedConstantsBar => ResolvedConstantsBar.b:I"))
             .shouldMatch(ALWAYS("field.* ResolvedConstantsBar => ResolvedConstantsBar.a:I"))
@@ -122,13 +123,14 @@
 
             // Should resolve references to own non-static method (private or public)
             .shouldMatch(ALWAYS("method.*: ResolvedConstantsBar ResolvedConstantsBar.doBar:"))
             .shouldMatch(ALWAYS("method.*: ResolvedConstantsApp ResolvedConstantsApp.privateInstanceCall:"))
             .shouldMatch(ALWAYS("method.*: ResolvedConstantsApp ResolvedConstantsApp.publicInstanceCall:"))
-
+/** premain allows static method pre-resolution
             // Should not resolve references to static method
             .shouldNotMatch(ALWAYS("method.*: ResolvedConstantsApp ResolvedConstantsApp.staticCall:"))
+**/
 
             // Should resolve references to method in super type
             .shouldMatch(ALWAYS("method.*: ResolvedConstantsBar ResolvedConstantsFoo.doBar:"))
 
             // Without -XX:+AOTClassLinking App class cannot resolve references to methods in boot classes:
@@ -146,18 +148,20 @@
             ;
 
 
         // Indy References ---
         if (aotClassLinking) {
+/** premain allows Old classes to be linked
             out.shouldContain("Cannot aot-resolve Lambda proxy because OldConsumer is excluded")
                .shouldContain("Cannot aot-resolve Lambda proxy because OldProvider is excluded")
                .shouldContain("Cannot aot-resolve Lambda proxy because OldClass is excluded")
                .shouldContain("Cannot aot-resolve Lambda proxy of interface type InterfaceWithClinit")
                .shouldMatch("klasses.* app *NormalClass[$][$]Lambda/.* hidden aot-linked inited")
                .shouldNotMatch("klasses.* app *SubOfOldClass[$][$]Lambda/")
                .shouldMatch("archived indy *CP entry.*StringConcatTest .* => java/lang/invoke/StringConcatFactory.makeConcatWithConstants")
                .shouldNotMatch("archived indy *CP entry.*StringConcatTestOld .* => java/lang/invoke/StringConcatFactory.makeConcatWithConstants");
+**/
         }
     }
 
     static String ALWAYS(String s) {
         return "cds,resolve.*archived " + s;
diff a/test/hotspot/jtreg/runtime/cds/appcds/test-classes/pkg3/Package3A.java b/test/hotspot/jtreg/runtime/cds/appcds/test-classes/pkg3/Package3A.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/test-classes/pkg3/Package3A.java
@@ -0,0 +1,27 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+package pkg3;
+
+public class Package3A {}
diff a/test/hotspot/jtreg/runtime/cds/appcds/test-classes/pkg3/Package3B.java b/test/hotspot/jtreg/runtime/cds/appcds/test-classes/pkg3/Package3B.java
--- /dev/null
+++ b/test/hotspot/jtreg/runtime/cds/appcds/test-classes/pkg3/Package3B.java
@@ -0,0 +1,27 @@
+/*
+ * Copyright (c) 2024, Oracle and/or its affiliates. All rights reserved.
+ * DO NOT ALTER OR REMOVE COPYRIGHT NOTICES OR THIS FILE HEADER.
+ *
+ * This code is free software; you can redistribute it and/or modify it
+ * under the terms of the GNU General Public License version 2 only, as
+ * published by the Free Software Foundation.
+ *
+ * This code is distributed in the hope that it will be useful, but WITHOUT
+ * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
+ * FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
+ * version 2 for more details (a copy is included in the LICENSE file that
+ * accompanied this code).
+ *
+ * You should have received a copy of the GNU General Public License version
+ * 2 along with this work; if not, write to the Free Software Foundation,
+ * Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA.
+ *
+ * Please contact Oracle, 500 Oracle Parkway, Redwood Shores, CA 94065 USA
+ * or visit www.oracle.com if you need additional information or have any
+ * questions.
+ *
+ */
+
+package pkg3;
+
+public class Package3B {}
